/*
Programa   : Emulador de prioridad de mensajes de correo
Autor      :  Oscar C. Oliva Gonzalez */
		 
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h> 										

// X y Y valores definidos por el Usuario, de tipo enteros

typedef struct msj
{     char clave[X];
	char texto[Y];
} *msjpnt;

typedef struct Nodo
{	struct msj info;
	Nodo *link;
} Enlace; */

class Cola
{    private:
     Enlace ini,fin;
    public:
     Cola();
     int Vacia();
     void Agregar(msj);
     msj Extraer();
     void Muestra(int &c);
//   msj Saca();
};

Cola::Cola()
{      cout <<"Creando Cola"<<endl<<endl;
       ini = new(Nodo);
       ini->link = NULL;
       fin = ini;
};

int Cola::Vacia()
{      return (ini==fin);
};

void Cola::Agregar(msj e)
{
     fin->info =e;
     fin->link = new(Nodo);
     fin = fin->link;
     fin->link = NULL;
};

msj Cola::Extraer()
{    struct msj x = ini->info;
     Enlace p = ini;
     ini = ini->link;
     delete p;
     return x;
};


void Cola::Muestra(int &c)
{
	gotoxy(15,2);

	printf("* PROGRAMA PRIORIDAD DE MENSAJES EN COLA *");
	int l=13;
	Enlace paux=ini;
	while (!Vacia())
	{
	      gotoxy(c,l);
	      cout <<Saca().clave<<endl;
	      l--;
	};
	ini=paux;
	gotoxy(75,9);
	printf("|");
	gotoxy(75,10);
	printf("V");
	gotoxy(4,15);
	cout<<"Cola Original"<<"                Cola Resultante";
	gotoxy(4,22);
	cout<<"- La Fecha de su derecha de la pantalla,indica direccion salida info de Cola";
	gotoxy(4,23);
	cout<<"- El formato del mensaje CCCTTTTTTTTTTT (CCC=Prioridad-TTTT..=Mensaje)";
	gotoxy(4,24);
	cout<<"- Presione ENTER para ver la Cola Resultante ";


	getche();
};

msj Cola::Saca()
{    msj x2 = ini->info;
     ini = ini->link;
     return x2;
};


void main()
// Creacion de Colas por color R=Roja prioridad (1), A=Azul (2), B=Blanca (3)
 {	Cola P,R,A,B;
	clrscr();
	int h=0;
	char c,t;
	char m[]="2";
	msj mensaje;
	char correoclave[X];
	char correomensa[Y];
	while (m[0] != '1')
	{
		h=0;
		cout<<"Ingrese Prioridad del Mensaje (Ingrese 3 caracteres Mayusculas) : "<<endl;
		while ((c=getchar()) != '\n')
		      correoclave[h++]=c;
		correoclave[h]='\0';
		h=0;
		cout<<"Ingrese Mensaje a enviar : "<<endl;
		cout<<"(Para efectos de visualizacin ingrese un m ximo de 20 caracteres)"<<endl;
		while ((t=getchar()) != '\n')
		      correomensa[h++]=t;
		correomensa[h]='\0';
		strcpy(mensaje.clave,correoclave);
		strcpy(mensaje.texto,correomensa);
		P.Agregar(mensaje);
		cout<<"DIGITE 1 PARA SALIR, ENTER PARA CONTINUAR"<<endl;
		gets(m);

	};
	clrscr();
	int col=4;
	P.Muestra(col);
	int i=0;
					// definir estructura de mcorreo;
	for(i=2;i>-1;i--)
	{
	   while (!P.Vacia())
	   {        mcorreo=P.Extraer();
		    if (mcorreo.clave[i]=='R')
			R.Agregar(mcorreo);
		    else
			if (mcorreo.clave[i]=='A')
			   A.Agregar(mcorreo);
			else
			    if (mcorreo.clave[i]=='B')
				B.Agregar(mcorreo);
		};
	    while (!R.Vacia())
		  P.Agregar(R.Extraer());
	    while (!A.Vacia())
		  P.Agregar(A.Extraer());
	    while (!B.Vacia())
		  P.Agregar(B.Extraer());
	};
	col=33;
/*	P.Muestra(col);  Display Queve Star */
};
